"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from) {
    for (var i = 0, il = from.length, j = to.length; i < il; i++, j++)
        to[j] = from[i];
    return to;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeployProject = void 0;
var commander_1 = __importDefault(require("commander"));
var ConfigManager_1 = require("../ConfigManager");
var utils_1 = require("../utils");
var ora_1 = __importDefault(require("ora"));
var index_1 = require("../index");
var fs = __importStar(require("fs"));
var form_data_1 = __importDefault(require("form-data"));
var chalk_1 = __importDefault(require("chalk"));
var UserService_1 = require("../user/UserService");
var shell = require('shelljs');
var md5File = require("md5-file");
exports.DeployProject = commander_1.default.program.createCommand('deploy')
    .description('Deploy project')
    .option('--skip-build', 'Wont execute the buildCmd command')
    .action(function (options) {
    if (!UserService_1.isLoggedIn()) {
        UserService_1.displayLoginError();
        return;
    }
    if (!ConfigManager_1.isProject()) {
        console.log(utils_1.Colors.FgRed + "Please initialize project first with " + utils_1.Colors.FgCyan + "upli init" + utils_1.Colors.Reset);
        return;
    }
    var spinner = ora_1.default('Prepare deployment');
    // hide spinner if debug is enabled
    if (commander_1.default.program.opts().debug) {
        utils_1.debug('Hide spinner for debug logging');
    }
    else {
        spinner.start();
    }
    var projectConfig = ConfigManager_1.loadConfig(ConfigManager_1.PROJECT_CONFIG_FILE);
    var buildPath = getFullBuildPath(projectConfig.project);
    utils_1.debug("configBuildPath: " + projectConfig.project.config.deploy.buildPath);
    utils_1.debug("fullBuildPath: " + buildPath);
    var buildCmd = projectConfig.project.config.deploy.buildCmd;
    spinner.text = "Build project with " + buildCmd;
    new Promise(function (resolve, reject) {
        if (!buildCmd || options.skipBuild) {
            resolve(null);
            return;
        }
        shell.exec(buildCmd, { silent: !utils_1.isDebug() }, function (code, stdout, stderr) {
            if (code !== 0) {
                reject({ stdout: stdout, stderr: stderr });
                return;
            }
            resolve({ code: code, stdout: stdout, stderr: stderr });
        });
    }).then(function (res) {
        spinner.text = 'Fetch server project structure';
        // get file hashes from server
        index_1.axiosInstance.get("/api/project/files/" + projectConfig.project.name)
            .then(function (res) { return __awaiter(void 0, void 0, void 0, function () {
            var serverProjectStructure, clientProjectStructure, removeFiles, patchFiles, deleteResponse, i, patchConfigResponse;
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        serverProjectStructure = res.data;
                        spinner.text = "Create patch (" + serverProjectStructure.length + " files found on server)";
                        clientProjectStructure = createLocalProjectStructure(projectConfig.project);
                        spinner.text = "Diff server(" + serverProjectStructure.length + ") <=> client(" + clientProjectStructure.length + ")";
                        utils_1.debug("serverProjectStructure: " + JSON.stringify(serverProjectStructure));
                        utils_1.debug("clientProjectStructure: " + JSON.stringify(clientProjectStructure));
                        removeFiles = serverProjectStructure.filter(function (serverFile) { return !clientProjectStructure.find(function (clientFile) { return clientFile.name == serverFile.name; }); });
                        patchFiles = clientProjectStructure.filter(function (clientFile) { return !serverProjectStructure.find(function (serverFile) { return serverFile.name == clientFile.name && serverFile.hash == clientFile.hash; }); });
                        spinner.text = "Remove " + removeFiles.length + " files";
                        utils_1.debug("remove " + removeFiles.length + " files");
                        return [4 /*yield*/, index_1.axiosInstance.post("/api/project/delete/" + projectConfig.project.name + "/files", {
                                files: removeFiles.map(function (f) { return f.name; }),
                                deleteEmptyFolders: true
                            })];
                    case 1:
                        deleteResponse = _b.sent();
                        utils_1.debug("deleteResponse " + JSON.stringify(deleteResponse.data));
                        spinner.text = "Patch " + patchFiles.length + " files";
                        utils_1.debug("patch " + patchFiles.length);
                        i = 0;
                        _b.label = 2;
                    case 2:
                        if (!(i < patchFiles.length)) return [3 /*break*/, 5];
                        return [4 /*yield*/, patchFilesAsync(projectConfig.project, patchFiles[i].name)];
                    case 3:
                        _b.sent();
                        _b.label = 4;
                    case 4:
                        i++;
                        return [3 /*break*/, 2];
                    case 5:
                        spinner.text = "Patch configuration";
                        return [4 /*yield*/, index_1.axiosInstance.post("/api/project/config/" + projectConfig.project.name, projectConfig.project.config)];
                    case 6:
                        patchConfigResponse = _b.sent();
                        if (patchConfigResponse.status != 200)
                            console.log(utils_1.Colors.FgRed + "Error while patching config: " + (patchConfigResponse === null || patchConfigResponse === void 0 ? void 0 : patchConfigResponse.data));
                        utils_1.debug("Configuration patched " + JSON.stringify(projectConfig.project.config));
                        spinner.text = 'Deployed!';
                        spinner.stop();
                        if (((_a = deleteResponse === null || deleteResponse === void 0 ? void 0 : deleteResponse.data) === null || _a === void 0 ? void 0 : _a.deletedFiles) && deleteResponse.data.deletedFiles.length > 0) {
                            deleteResponse.data.deletedFiles.forEach(function (deletedFile) { return console.log(chalk_1.default.yellow("Deleted: " + deletedFile)); });
                        }
                        if (patchFiles.length == 0) {
                            console.log(utils_1.Colors.FgYellow + "No changes were detected and therefore nothing deployed to " + chalk_1.default.bold('https://' + projectConfig.project.domain) + " !" + utils_1.Colors.Reset);
                        }
                        else {
                            patchFiles.forEach(function (file) { return console.log(utils_1.Colors.FgMagenta + "Patched: " + file.name + " " + file.hash); });
                            console.log(utils_1.Colors.FgGreen + "Successfully deployed " + patchFiles.length + " files to " + chalk_1.default.bold('https://' + projectConfig.project.domain) + " !" + utils_1.Colors.Reset);
                        }
                        return [2 /*return*/];
                }
            });
        }); }).catch(function (err) { return spinner.stop(); });
    }).catch(function (err) {
        spinner.stop();
        console.log(chalk_1.default.red("Could not build project: \n" + err.stderr));
    });
});
function getFullBuildPath(project) {
    var _a;
    return utils_1.normalizePath(process.cwd() + '/' + ((_a = project.config.deploy.buildPath) !== null && _a !== void 0 ? _a : '') + '\/');
}
var patchFilesAsync = function (project, file) { return __awaiter(void 0, void 0, void 0, function () {
    var filepath, form_data, response, err_1;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                _a.trys.push([0, 2, , 3]);
                filepath = getFullBuildPath(project) + file.split('/').join('\\');
                form_data = new form_data_1.default();
                form_data.append('file', fs.createReadStream(filepath));
                utils_1.debug("patch " + filepath);
                return [4 /*yield*/, index_1.axiosInstance.post("/api/project/upload/" + project.name + file, form_data, {
                        headers: {
                            'Content-Type': 'multipart/form-data; boundary=' + form_data.getBoundary()
                        }
                    })];
            case 1:
                response = _a.sent();
                utils_1.debug("patched " + filepath + " => " + (response === null || response === void 0 ? void 0 : response.data));
                return [3 /*break*/, 3];
            case 2:
                err_1 = _a.sent();
                console.error(err_1);
                return [3 /*break*/, 3];
            case 3: return [2 /*return*/];
        }
    });
}); };
function createLocalProjectStructure(project) {
    var fullBuildPath = getFullBuildPath(project);
    return getFileHashesFromFolder(fullBuildPath, fullBuildPath);
}
function getFileHashesFromFolder(directory, projectDirectory) {
    var files = [];
    fs.readdirSync(directory).forEach(function (file) {
        file = directory + '\\' + file;
        if (fs.lstatSync(file).isDirectory()) {
            files = __spreadArray(__spreadArray([], files), getFileHashesFromFolder(file, projectDirectory));
        }
        else {
            files.push({
                name: file.replace(projectDirectory, '').split('\\').join('/').split('//').join('/'),
                hash: md5File.sync(file)
            });
        }
    });
    return files;
}
