"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.InitProject = void 0;
var commander_1 = __importDefault(require("commander"));
var ConfigManager_1 = require("../ConfigManager");
var utils_1 = require("../utils");
var ora_1 = __importDefault(require("ora"));
var index_1 = require("../index");
var chalk_1 = __importDefault(require("chalk"));
var UserService_1 = require("../user/UserService");
var prompts = require('prompts');
exports.InitProject = commander_1.default.program.createCommand('init')
    .description('Initialize project in current path')
    .action(function () {
    if (!UserService_1.isLoggedIn()) {
        UserService_1.displayLoginError();
        return;
    }
    if (ConfigManager_1.isProject()) {
        console.log(utils_1.Colors.FgRed + " This project has already been initialized" + utils_1.Colors.Reset);
    }
    else {
        (function () { return __awaiter(void 0, void 0, void 0, function () {
            var detectedFramework, promptResponse, spinner_1, selectedFramework, project_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        detectedFramework = utils_1.detectFramework();
                        return [4 /*yield*/, prompts([
                                {
                                    type: 'text',
                                    name: 'name',
                                    message: "Project Name?",
                                    initial: ConfigManager_1.getCurrentFolderName(),
                                    validate: function (name) {
                                        if (name == 'exist') // TODO: check if project already exist
                                            return "This project name already exist in your user account. You can delete it with " + utils_1.Colors.FgCyan + "upli project rm " + name;
                                        return true;
                                    }
                                },
                                {
                                    type: 'select',
                                    name: 'framework',
                                    message: 'Select a framework',
                                    choices: utils_1.Frameworks.map(function (f) { return ({
                                        title: f.title,
                                        value: f.defaultConfig.framework,
                                        description: detectedFramework == f ? '(Auto detected)' : null
                                    }); }),
                                    initial: utils_1.Frameworks.indexOf(detectedFramework)
                                },
                                {
                                    type: 'toggle',
                                    name: 'confirmation',
                                    message: 'Should the project be created now?',
                                    initial: true,
                                    active: 'yes',
                                    inactive: 'no'
                                }
                            ])];
                    case 1:
                        promptResponse = _a.sent();
                        if (promptResponse.confirmation) {
                            spinner_1 = ora_1.default('Create project').start();
                            selectedFramework = utils_1.Frameworks.find(function (f) { return f.defaultConfig.framework == promptResponse.framework; });
                            if (!selectedFramework) {
                                console.log(chalk_1.default.red("Framework " + promptResponse.framework + " not found"));
                                return [2 /*return*/];
                            }
                            project_1 = {
                                name: promptResponse.name,
                                config: selectedFramework.defaultConfig
                            };
                            index_1.axiosInstance.post('/api/project/create', project_1).then(function (res) {
                                spinner_1.stop();
                                console.log(utils_1.Colors.FgGreen + "Project created at " + chalk_1.default.bold('https://' + res.data.domain) + " !" + utils_1.Colors.Reset);
                                project_1.domain = res.data.domain;
                                ConfigManager_1.writeConfig(ConfigManager_1.PROJECT_CONFIG_FILE, {
                                    project: project_1,
                                    version: utils_1.packageVersion
                                });
                            }).catch(function () { return spinner_1.stop(); });
                        }
                        return [2 /*return*/];
                }
            });
        }); })();
    }
});
