"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Colors = exports.normalizePath = exports.isDebug = exports.debug = exports.delay = exports.Frameworks = exports.detectFramework = exports.packageVersion = void 0;
var fs = __importStar(require("fs"));
var commander_1 = require("commander");
var packageJson = require('../package.json');
exports.packageVersion = packageJson.version;
function detectFramework() {
    var files = fs.readdirSync(process.cwd());
    if (files.includes('angular.json'))
        return exports.Frameworks.find(function (f) { return f.defaultConfig.framework == 'angular'; });
    // TODO: add react detection
    return exports.Frameworks.find(function (f) { return f.defaultConfig.framework == 'none'; });
}
exports.detectFramework = detectFramework;
exports.Frameworks = [
    {
        title: 'No framework',
        defaultConfig: {
            framework: 'none',
            mapping: [
                {
                    path: '/',
                    file: 'index.html'
                }
            ],
            deploy: {
                ignored: [],
                buildPath: null,
                buildCmd: null
            }
        }
    },
    {
        title: 'Angular',
        defaultConfig: {
            framework: 'angular',
            mapping: [
                {
                    path: '404',
                    file: 'index.html'
                }
            ],
            deploy: {
                ignored: [],
                buildPath: 'dist/build',
                buildCmd: 'ng build --output-path dist/build'
            }
        }
    },
    {
        title: 'React',
        defaultConfig: {}
        // TODO: add default config for react
    }
];
/*
export enum Framework {
    NONE,
    ANGULAR,
    REACT
}*/
function delay(time) {
    return new Promise(function (resolve) { return setTimeout(function () { return resolve(null); }, time); });
}
exports.delay = delay;
function debug(msg) {
    if (commander_1.program.opts().debug) {
        console.log("" + Colors.BgBlue + Colors.FgWhite + "[DEBUG]" + Colors.BgBlack + Colors.FgCyan + " " + msg + Colors.Reset);
    }
}
exports.debug = debug;
var isDebug = function () { return commander_1.program.opts().debug; };
exports.isDebug = isDebug;
var normalizePath = function (file) { return file.split('\\').join('/').split('//').join('/'); };
exports.normalizePath = normalizePath;
var Colors;
(function (Colors) {
    Colors["Reset"] = "\u001B[0m";
    Colors["Bright"] = "\u001B[1m";
    Colors["Dim"] = "\u001B[2m";
    Colors["Underscore"] = "\u001B[4m";
    Colors["Blink"] = "\u001B[5m";
    Colors["Reverse"] = "\u001B[7m";
    Colors["Hidden"] = "\u001B[8m";
    Colors["FgBlack"] = "\u001B[30m";
    Colors["FgRed"] = "\u001B[31m";
    Colors["FgGreen"] = "\u001B[32m";
    Colors["FgYellow"] = "\u001B[33m";
    Colors["FgBlue"] = "\u001B[34m";
    Colors["FgMagenta"] = "\u001B[35m";
    Colors["FgCyan"] = "\u001B[36m";
    Colors["FgWhite"] = "\u001B[37m";
    Colors["BgBlack"] = "\u001B[40m";
    Colors["BgRed"] = "\u001B[41m";
    Colors["BgGreen"] = "\u001B[42m";
    Colors["BgYellow"] = "\u001B[43m";
    Colors["BgBlue"] = "\u001B[44m";
    Colors["BgMagenta"] = "\u001B[45m";
    Colors["BgCyan"] = "\u001B[46m";
    Colors["BgWhite"] = "\u001B[47m";
})(Colors = exports.Colors || (exports.Colors = {}));
